



#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/interrupt.h>
#include <sleep_bod_disable.h>
#include <Wire2.h>


#define pin_led 13
#define pin_sensor_power 10
#define pin_tx_power 7
#define pin_tx_data 6


int mode_speed=5;  // bigger == slower
int mode_slowspeed=5;
int mode_count=0;
int mode_switch=5; // after mode_count equals this switch to slow mode
int mode_slow=0;     // true when in slow mode







/*********************************************************************************************/



// do stuff

void payload(void)
{
// for checking accuracy  
 Serial.println("*");
 Serial.flush();
  



 if(!mode_slow) // flash the LED at first (whilst in slow mode)
 {
  pinMode(pin_led, OUTPUT);
  digitalWrite(pin_led, LOW);
  delay(100);
  digitalWrite(pin_led, HIGH);
  delay(100); 
  pinMode(pin_led, INPUT);  
 }

  Serial.flush();
}  



void power_down(void)
{

 // power down connected hardware
  
}

void power_up(void)
{

 // poweer up connected hardware

}






#ifndef sleep_bod_disable() // not included in Arduino AVR toolset
#define sleep_bod_disable() \
do { \
  uint8_t tempreg; \
  __asm__ __volatile__("in %[tempreg], %[mcucr]" "\n\t" \
                       "ori %[tempreg], %[bods_bodse]" "\n\t" \
                       "out %[mcucr], %[tempreg]" "\n\t" \
                       "andi %[tempreg], %[not_bodse]" "\n\t" \
                       "out %[mcucr], %[tempreg]" \
                       : [tempreg] "=&d" (tempreg) \
                       : [mcucr] "I" _SFR_IO_ADDR(MCUCR), \
                         [bods_bodse] "i" (_BV(BODS) | _BV(BODSE)), \
                         [not_bodse] "i" (~_BV(BODSE))); \
} while (0)
#endif



//#define OVERFLOWMODE 1

#define CTCMODE 1

#ifdef CTCMODE
// interrupt on Timer 2 compare "A" completion - does nothing
EMPTY_INTERRUPT (TIMER2_COMPA_vect);
#endif

#ifdef OVERFLOWMODE
EMPTY_INTERRUPT(TIMER2_OVF_vect);
#endif


byte adcsra;

void power_down_lowlevel(void)
{
 adcsra = ADCSRA;                  //save the ADC Control and Status Register A
 ADCSRA = 0;
 power_adc_disable ();
 power_spi_disable();
 power_twi_disable();
 power_timer0_disable();
 power_timer1_disable();
 power_usart0_disable();
}


void power_up_lowlevel(void)
{
 ADCSRA = adcsra;
 power_timer0_enable();
 power_timer1_enable();
 power_usart0_enable();
 power_adc_enable();  
 power_spi_enable();
 power_twi_enable();  
}  


long next_count;


int  target_reached;
int  realtarget_period=(5*8*32);
double corr_factor=6.8442e-5;
int  remaining_count;
double error_count;

// event 400 15998905 error 1095

void getnexttarget(void)
{
 int temp;
 
 remaining_count=realtarget_period;
 
 error_count+=corr_factor*(double)realtarget_period;
 temp=(int)(error_count);
 remaining_count+=temp;
 error_count-=(double)temp;
 
}


void loop() 
{ 
 power_down();


 power_down_lowlevel(); 
  
 while(1)
 {
  if(remaining_count<=0)
  {
   getnexttarget();
   target_reached=1;
  }
  else
  {
   target_reached=0;    
  }

  next_count=remaining_count;

  if(next_count>256 && next_count<(256+128))
  {  
   next_count=next_count/2;
  }
  else 
  if(next_count>256)
  {
   next_count=256;
  }   
  remaining_count-=next_count;
  
#ifdef OVERFLOWMODE  
  next_count=256-next_count;
#endif


  
  cli();
  set_sleep_mode(SLEEP_MODE_PWR_SAVE);  
  sleep_enable();
  sleep_bod_disable();
  sei();
  sleep_cpu();

#ifdef OVERFLOWMODE
    TCNT2 = next_count;
    OCR2A = 0;                        //write to OCR2A, we're not using it, but no matter
    while (ASSR & _BV(OCR2AUB)) {}    //wait for OCR2A to be updated
#endif

#ifdef CTCMODE
     OCR2A=(next_count-1);
     while (ASSR & _BV(OCR2AUB)) {}    //wait for OCR2A to be updated
   
#endif

  sleep_disable();
//   power_up_lowlevel();
  if(target_reached) break;
 }
  

 power_up_lowlevel();

 power_up();

 payload();

 if(mode_count++==mode_switch)
 {
  mode_speed=mode_slowspeed;
  mode_slow=1;
 }
 

}
  
  
  
  
void setup() 
{
 Serial.begin(9600);        // connect to the serial port  

  
 
 
 getnexttarget();



#ifdef CTCMODE  
  // clock input to timer 2 from XTAL1/XTAL2
 ASSR = bit (AS2);  

  // set up timer 2 to count up to 32 * 1024  (32768)
 TCCR2A = bit (WGM21);                             // CTC
 TCCR2B = bit (CS20) | bit (CS21) | bit (CS22);    // Prescaler of 1024                                  
 OCR2A =  255;              // count to 32 (zero-relative)                  

  // enable timer interrupts
 TIMSK2 |= bit (OCIE2A);
  
#endif

#ifdef OVERFLOWMODE

 //Set up TIMER2
    TIMSK2 = 0;                        //stop timer2 interrupts while we set up
    ASSR = _BV(AS2);                   //Timer/Counter2 clocked from external crystal
    TCCR2A = 0;                        //override arduino settings, ensure WGM mode 0 (normal mode)
    TCCR2B = _BV(CS22) | _BV(CS21) | _BV(CS20);    //prescaler clk/1024 -- TCNT2 will overflow once every 8 seconds
    TCNT2 = 0;                         //start the timer at zero
    while (ASSR & (_BV(TCN2UB) | _BV(TCR2AUB) | _BV(TCR2BUB))) {}    //wait for the registers to be updated    
    TIFR2 = _BV(OCF2B) | _BV(OCF2A) | _BV(TOV2);                     //clear the interrupt flags
    TIMSK2 = _BV(TOIE2);               //enable interrupt on overflow

#endif
  

}

  
